version: "3"
services:
  mysqldb:
    container_name: mysqldb
    image: mysql
    ports:
      - "3307:3306"
    volumes:
      - ./init.sql:/docker-entrypoint-initdb.d/init.sql
    environment:
      MYSQL_DATABASE: TaskManagementApp
      MYSQL_ROOT_PASSWORD: 1234
      MYSQL_PASSWORD: 1234
    healthcheck:
      test: ["CMD-SHELL", "mysqladmin ping -h localhost -u root -p1234"]
      timeout: 20s
      retries: 10


  springboot-app:
    container_name: spring-app
    image: springboot-app
    restart: on-failure
    build: .
    ports:
      - "8080:8080"
    environment:
      SPRING_DATASOURCE_URL: jdbc:mysql://mysqldb:3306/TaskManagementApp  # we are in same network so we connect internally.
      SPRING_DATASOURCE_USERNAME: root
      SPRING_DATASOURCE_PASSWORD: 1234
    depends_on:
      mysqldb:
        condition: service_healthy